<?php
App::uses('Component', 'Controller');

class CustomFieldsComponent extends Component
{
    private $__controller = null;

    /**
     * Sets a reference to the calling controller from within the component.
     *
     * @see Component::initialize()
     */
    public function initialize(Controller $controller) {

        parent::initialize($controller);

        $this->__controller = $controller;
    }

    /**
     * run the form injection
     * For custom fields this add type / validation arrays to the template for fields
     *
     * @param   array       Data from $this->request->data
     * @param   object      Model Object for the primary model we are dealing with
     * @param   int|null    The ID if on edit or null of add
     */
    public function injectAdminForm($data, $Model, $id)
    {
        $this->__controller->set(
            array(
                'types' => array(
                    'string' => 'Input Box',
                    'text_plain' => 'Textarea',
                    'select' => 'Select',
                    'html_lite' => 'WYSIWYG Lite',
                    'html' => 'WYSIWYG',
                    'boolean' => 'Checkbox',
                    'date' => 'Date Picker',
                    'datetime' => 'Date Time Picker',
                    'map' => 'Map'
                )
            )
        );
    }
}
